package org.eclipse.palamedes.kif.core.ast;

public class KIFFunTerm extends KIFTerm {

    private       String          constName;
    private final KIFSeq<KIFTerm> terms     = new KIFSeq<KIFTerm>();

    KIFFunTerm(AST ast) {
        super(ast);
    }

    @Override
    public final String getName() {
        return constName;
    }

    @Override
    public final KIFSeq<KIFTerm> getTerms() {
        return terms;
    }

    public final void setConstName(String constName) {
        this.constName = constName;
    }

    @Override
    ASTNode clone0(AST ast) {
        KIFFunTerm newNode = ast.newFunTerm(constName, terms.clone0(ast));
        newNode.setSourceStart ( getSourceStart()  );
        newNode.setSourceLength( getSourceLength() );
        return newNode;
    }

    @Override
    final int getNodeType0() {
        return ASTNode.FUNTERM;
    }

    @Override
    public void traverse(ASTVisitor visitor) {
        visitor.visit(this);
    }

    @Override
    boolean subtreeMatch0(ASTMatcher matcher, Object other) {
        return matcher.match(this, other);
    }

    protected final void copyMembers(KIFFunTerm node) {
        super.copyMembers(node);
        constName = node.constName;
        terms.addAll(node.terms);
        terms.trimToSize();
    }
}
