package org.eclipse.palamedes.kif.core.ast;

public class KIFLogConst extends KIFSent {

    private String constName;

    protected KIFLogConst(AST ast) {
        super(ast);
    }

    @Override
    public final String getName() {
        return constName;
    }

    public final void setConstName(String logConst) {
        constName = logConst;
    }

    @Override
    ASTNode clone0(AST ast) {
        KIFLogConst newNode = ast.newLogConst(constName);
        newNode.setSourceStart ( getSourceStart()  );
        newNode.setSourceLength( getSourceLength() );
        return newNode;
    }

    @Override
    final int getNodeType0() {
        return ASTNode.LOGCONST;
    }

    @Override
    public void traverse(ASTVisitor visitor) {
        visitor.visit(this);
    }

    @Override
    boolean subtreeMatch0(ASTMatcher matcher, Object other) {
        return matcher.match(this, other);
    }

    @Override
    public String toString() {
        return constName;
    }

    @Override
    public int getOperandCount() {
        return 0;
    }

    @Override
    public KIFSeq<KIFSent> getOperands() {
        return new KIFSeq<KIFSent>();
    }

    protected final void copyMembers(KIFLogConst node) {
        super.copyMembers(node);
        constName = node.constName;
    }


}
