package org.eclipse.palamedes.kif.core.ast;

public class KIFObjConst extends KIFTerm {

    private String constName;

    KIFObjConst(AST ast) {
        super(ast);
    }

    @Override
    public final String getName() {
        return constName;
    }

    public final void setConstName(String constName) {
        this.constName = constName;
    }

    @Override
    ASTNode clone0(AST ast) {
        KIFObjConst newNode = ast.newObjConst(constName);
        newNode.setSourceStart ( getSourceStart()  );
        newNode.setSourceLength( getSourceLength() );
        return newNode;
    }

    @Override
    int getNodeType0() {
        return ASTNode.OBJCONST;
    }

    @Override
    public void traverse(ASTVisitor visitor) {
        visitor.visit(this);
    }

    @Override
    boolean subtreeMatch0(ASTMatcher matcher, Object other) {
        return matcher.match(this, other);
    }

    protected final void copyMembers(KIFObjConst node) {
        super.copyMembers(node);
        constName = node.constName;
    }

	@Override
	public KIFSeq<KIFTerm> getTerms() {
		return new KIFSeq<KIFTerm>();
	}
}
